//---------------------------------------------------------------------------
//	Takahiro Hayashi 2001.06.27
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------


#define	OP_POP	1			// POP					X^bN̒loB
#define OP_PSHN 3			// PSHN		num			X^bNɐlς
#define OP_CAL	4
#define OP_LBL	5
#define OP_JP		20		//	JP		LABEL		LABEL֖Wv
#define OP_JPZ		21		//	JPZ		LABEL		X^bN̒lPOPA0̎ɁALABELփWv
#define OP_POPI		22		//	POPI	int			POP INT : X^bN̒lPOPAintɊi[
#define OP_POPP		23		//	POPP	char*		POP Pointer : X^bN̒lPOPAchar*Ɋi[
#define OP_PSHI		24		//	PSHI	immediate	PUSH INT : immediateX^bNɐς
#define OP_PSHP		25		//	PSHP	char*		PUSH Pointer : char*i|C^jX^bNɐς
#define OP_INC		26		//	INC		++
#define OP_DEC		27		//	DEC		--
#define OP_ADD		28		//	ADD		+
#define OP_SUB		29		//	SUB		-
#define OP_MUL		30		//	MUL		*
#define OP_DIV		31		//	DIV		/
#define OP_MIN		32		//	MIN		-N
#define OP_EQ		33		//	EQ		==
#define OP_NEQ		34		//	NEQ		!=
#define OP_GT		35		//	GT		>
#define OP_GE		36		//	GE		>=
#define OP_LS		37		//	LS		<
#define OP_LE		38		//	LE		<=
#define OP_AND		39		//	AND		&&
#define OP_OR		40		//	OR		||
#define OP_STRCPY	50		// strcpy()
#define OP_STRCAT	51		// strcat()
#define OP_STRCMP	52		// strcmp()
#define OP_ATOI		53		// atoi()
#define OP_ITOA		54		// atoi()
#define OP_DATE		55		// date()
#define OP_SSTPSEND	56		// sstpsend()		sstpNCAg
#define OP_SAVE		57		// save()		
#define OP_LOAD		58		// load()		
#define OP_GET_INITFILEDATA		59		// get_initfiledata()		
#define OP_RAND		60		// rand()		
#define OP_SAORICALL	61	// saoricall()
#define OP_ANDC		62		//	ANDCalc		&
#define OP_ORC		63		//	ORCalc		|


#define	ADD		1
#define	SUB		2
#define	MUL		3
#define	DIV		4
#define	MIN		5
#define	EQ		6
#define	NEQ		7
#define	NT		7
#define	GT		8
#define	GE		9
#define	LS		10
#define	LE		11
#define	AND		12
#define	OR		13
#define	STRCPY	14		// strcpy()
#define STRCAT	15		// strcat()
#define	STRCMP	16		// strcmp()
#define ATOI	17		// atoi()
#define ITOA	18		// atoi()
#define DATE	19		// date()
#define SSTPSEND	20	// sstpsend()
#define SAVE	21		// save()
#define LOAD	22		// load()
#define GET_INITFILEDATA	23		// get_initfiledata()
#define RAND	24		// rand()
#define SAORICALL	25	// saoricall()
#define	ANDC	26
#define	ORC		27




#define S22EVENT_EVENT			0
#define S22EVENT_REFERENCE0		1
#define S22EVENT_REFERENCE1		2
#define S22EVENT_REFERENCE2		3
#define S22EVENT_REFERENCE3		4
#define S22EVENT_REFERENCE4		5
#define S22EVENT_REFERENCE5		6
#define S22EVENT_REFERENCE6		7
#define S22EVENT_REFERENCE7		8

#define SYSTEM_RESERVE		30			// VXe̗\ϐ̈
#define NASINO_CODE_NUM		150			// ϐ̐

// lexŕԂe[uԍ
#define SHIORI_EVENT			1
#define SHIORI_REFERENCE0		2
#define SHIORI_REFERENCE1		3
#define SHIORI_REFERENCE2		4
#define SHIORI_REFERENCE3		5
#define SHIORI_REFERENCE4		6
#define SHIORI_REFERENCE5		7
#define SHIORI_REFERENCE6		8
#define SHIORI_REFERENCE7		9
#define USER_EVENT				11
#define USER_REFERENCE0			12
#define USER_REFERENCE1			13
#define USER_REFERENCE2			14
#define USER_REFERENCE3			15
#define USER_REFERENCE4			16
#define USER_REFERENCE5			17
#define USER_REFERENCE6			18
#define USER_REFERENCE7			19
#define TALK_INTERVAL			20		// talk_interval nasino.ini bԊu

#define REFERENCE_MAX			7


struct code{
	int opecode;
	int subcode;
};

struct sym{
	char *name;
	int value;
};


//---------------------------------------------------------------------------

//
int yyparse (void);
int yylex(void);

// nasino_script.cpp
int nasino_script_init(char*);
int nasino_script_main(struct s20_data *inputevent);
void nasino_script_unload();

void nasino_script_codegenerator(int opecode,int subcode);
int nasino_script_execute(void);

int nasino_script_getstack(int *sp);
int nasino_script_getstringtype(int num);
char *nasino_script_getstackstring(int *sp);				//	sX^bN̕ϐEString̓e̎o
int nasino_script_setstackstring(int *sp,char *string);		// sX^bN̕ϐEString̓e̊i[
char *nasino_script_getchardim(int num,int dim);
int nasino_script_setchardim(int num,int dim,char *word);
int nasino_script_getchardim_num(int num);
int nasino_script_getstring(char *word,int num);
int nasino_script_getstackval(int sp);						//	sX^bN̕ϐEl̓e̎o
int nasino_script_setstackval(int sp,int num,int val_type);	//	sX^bNւ̕ϐEl̊i[
void nasino_script_dumpcode();
int nasino_script_genlabel();
int nasino_script_labelcomp(void);
int string_pool(char* symbol);
int symbol_look(char* symbol);
char *get_symbol_name(int num);
int put_symbol_value(int num,int value);
void script_datadump(void);
int script_logwrite(char* logword);

//---------------------------------------------------------------------------
extern int Reserve_Num;
extern int Code_Num;
extern char LogTmp[AnswerLength];

//---------------------------------------------------------------------------
//		\؂̍쐬
//---------------------------------------------------------------------------

struct node{
	int ntype;
	int nvalue;
	struct node *left;
	struct node *right;
};

#define ID		100
#define NUM		101
#define STR		102
#define NON		103
#define STACK	104
#define DIM		105

class tree{
	struct node *codearea;
	int node_num;
	int node_max;
public:
	int init(int num);							// 
	int clear(void);							// ̈
	void clearnodearea();						// nodë̗
	struct node *getnodearea();					// nodë̗m
	struct node *makenode(int type,int value);	// node쐬
	struct node *makebranch(int type,struct node *node_left,struct node *node_right);
	int call_codegenerater(struct node *root);	// R[hWFl[^̌Ăяo
};

// nodë̗
void tree::clearnodearea()
{
	node_num = 0;
	return;
}

// nodë̗m
struct node *tree::getnodearea()
{
	struct node *root;

	if(node_num >= node_max){
		printf("nodeGA܂\n");
		script_logwrite("nodeGÅmۂ܂\n");
		root = NULL;
	}else{
		root = &codearea[node_num];
		node_num++;
	}
	
	return(root);
}

// node쐬
struct node *tree::makenode(int type,int value)
{
	struct node *root;

	root = getnodearea();
	root->ntype = type;
	root->nvalue = value;
	root->left = NULL;
	root->right = NULL;
	
//	printf("makenode:%d:%d:%d\n",type,value,root);
	return (root);
}

// ̍쐬
struct node *tree::makebranch(int type,struct node *node_left,struct node *node_right)
{
	struct node *root;
	
	root = makenode(type,0);
	root->left = node_left;
	root->right = node_right;

//	printf("makebranch:%d:%d:%d:%d\n",type,root,node_left,node_right);
	return(root);
}

// R[hWFl[^̌Ăяo
int tree::call_codegenerater(struct node *root)
{
	int riget_type;
	int left_type;
	int ret;
	
//	ret = TYPE_NOT;
//	ret = 0;

//	printf("tree::call_codegenerater:%d:%d\n",root->ntype,root);
	if(root != NULL){
		if(root->left){
			left_type = call_codegenerater(root->left);
//			printf("left:%d\n",left_type);
		}else{
			if(root->ntype == DIM){		// z̓Yꍇ̓|C^Ƃ
				printf("hit!!\n");
				nasino_script_codegenerator(OP_PSHN, -1);
			}
			left_type = 0;
		}

		if(root->right){
			riget_type = call_codegenerater(root->right);
//			printf("riget:%d\n",riget_type);
		}else{
			riget_type = 0;
		}


		switch(root->ntype){
			case ID:
				printf("ID:%d\n",root->nvalue);
				ret = nasino_script_getstringtype(root->nvalue);
//				printf("type:%d\n",ret);
				nasino_script_codegenerator(OP_PSHI, root->nvalue);
				break;
			case DIM:
				// ϐ̃^Cv𒲂ׁAzƂďꂽmFB
				printf("DIM %d %d\n",riget_type,left_type);
//				nasino_script_codegenerator(OP_PSHI, root->nvalue);
				break;
			case NUM:
//				ret = TYPE_NUM;
				ret = 3;
				nasino_script_codegenerator(OP_PSHN, root->nvalue);
				break;
			case STR:
				nasino_script_codegenerator(OP_PSHP, root->nvalue);
				break;
			case ATOI:
				nasino_script_codegenerator(OP_ATOI, root->nvalue);
				break;
			case ITOA:
				nasino_script_codegenerator(OP_ITOA, root->nvalue);
				break;
			case RAND:
				nasino_script_codegenerator(OP_RAND, root->nvalue);
				break;
			case DATE:
				nasino_script_codegenerator(OP_DATE, root->nvalue);
				break;
			case STRCPY:
				nasino_script_codegenerator(OP_STRCPY, root->nvalue);
				break;
			case STRCAT:
				nasino_script_codegenerator(OP_STRCAT, root->nvalue);
				break;
			case STRCMP:
				nasino_script_codegenerator(OP_STRCMP, root->nvalue);
				break;
			case SSTPSEND:
				nasino_script_codegenerator(OP_SSTPSEND, root->nvalue);
				break;
			case SAORICALL:
				nasino_script_codegenerator(OP_SAORICALL, root->nvalue);
				break;
			case SAVE:
				nasino_script_codegenerator(OP_SAVE, root->nvalue);
				break;
			case LOAD:
				nasino_script_codegenerator(OP_LOAD, root->nvalue);
				break;
			case GET_INITFILEDATA:
				nasino_script_codegenerator(OP_GET_INITFILEDATA, root->nvalue);
				break;
			case NON:
				break;
			default:
				nasino_script_codegenerator(OP_CAL, root->ntype);
				break;
		}
	}
//	ret = nasino_script_getstringtype(root->nvalue);
//	printf("type:%d\n",ret);
	return(ret);
//	return(root->nvalue);
}

// 
int tree::init(int num)
{
	int ret;
	// symbolGÅm
	if( (codearea = (struct node *)malloc(sizeof(struct node) * num) ) == NULL){
		// error
		printf("nodeGÅmۂł܂\n");
		script_logwrite("nodeGÅmۂł܂\n");
		ret = NG;
	}else{
		ret = OK;
	}
	
	node_num = 0;
	node_max = num;
	
	return(ret);
}


// ̈
int tree::clear(void)
{
	int count1;
	
//	printf("clear\n");
	
	free(codearea);
	
	return(0);
}

//---------------------------------------------------------------------------
//		ϐ̊i[E肾
//---------------------------------------------------------------------------
//	ϐ̌^
#define	TYPE_NOT		0		// s
#define	TYPE_INT		1		// lϐ
#define	TYPE_CHAR		2		// ϐ
#define	TYPE_NUM		3		// l
#define TYPE_STR		4		// iϐł͂Ȃj
#define TYPE_INTDIM		5		// intz
#define TYPE_CHARDIM	6		// intz


class symbol{
	struct stringdim{			// char^z̗vf
		char *string;
		stringdim *next_pointer;
	};
	struct symbolname{
		char *name;				// ϐ̖O
		int value;						// int:l
		char *string;					// char:eLXg
		stringdim *dimfirst_pointer;		// char^z擪|C^
		int stringdim_num;				// char^ž
		int type;						// symboľ^
		symbolname *next_pointer;
	};
	symbolname *symbolname_pointer;		// ϐi[Xg̐擪|C^
	int symbol_num;
//	int symbol_max;
	char return_string[10];					// Ԃl쐬p
	char dummy_string;					// string̒gȂƂ̃_~[
	void symbolname_free(struct symbolname *symbolname_pointer);
	void symboldim_free(struct stringdim *stringdim_pointer);
public:
//	int init(int num);						//  /
	int init(void);							//  /
	int clear(void);						// ̈ /
	int read_num(void);						// ̐ /
	int make(char *symbol);					// ϐ̍쐬 /
	int make_entory(char *symbol,int valtype);	// ϐ̍쐬Błɓ̕ϐ݂Ăꍇ͔ԍ݂̂Ԃ
	int serch(char *symbol,int);				// ϐ̃T[` /
	char *get_symbol_name(int num);			// ϐ̖O̎o /
	int set_symbol_type(int num,int type);	// type̐ݒ int:char /
	int get_symbol_type(int num);			// type̎o int:char /
	int set_symbol_val(int num,int value);	// ϐl̊i[ /
	int get_symbol_val(int num);			// ϐl̎o /
	int set_symbol_str(int num,char *word);	// ϐ̊i[
	char *get_symbol_str(int num);			// ϐ̎o
	int set_symbol_strdim(int num,int dim,char *word);	// zϐ̊i[
	char *get_symbol_strdim(int num,int dim);	// zϐ̎o
	int push_string(char *word);	// ̊i[
	char *pop_string(int num);		// ̎肾
	int logwrite_s(char* logword);
};

int symbol::logwrite_s(char* logword)
{
	FILE *fp_log;
	char filename[DataLength];
	
//	if(Log == ON){
//		sprintf(filename,"%s%s",DataPath,TESTLOG_FILENAME);
//		printf("ini filename : %s\n",filename);

		if((fp_log = fopen("c:\\nasino.log","at"))==NULL){
			/* nasino.ini don't open!! */
			printf("testlogfile don't open!!\n");
			return(0);
		}else{
			fputs(logword,fp_log);
			fclose(fp_log);
		}
//	}

	return(0);
}

void symbol::symbolname_free(struct symbolname *symbolname_pointer){
	char Log[1024];

//	logwrite_s("symbol::symbolname_free\n");
	if(symbolname_pointer->next_pointer != NULL){
//		logwrite_s("symbolname_pointer->next_pointer\n");
//		printf("1:stringname_pointer:%s\n",symbolname_pointer->name);
		symbolname_free(symbolname_pointer->next_pointer);
//		printf("%d\n",symbolname_pointer->next_pointer);
		free(symbolname_pointer->next_pointer);
		symbolname_pointer->next_pointer = NULL;
//		logwrite_s("symbolname_pointer->next_pointer end\n");
	}
	// z̃
//	logwrite_s("z̃\n");
//	sprintf(Log,"type:%d name:%s\n",symbolname_pointer->type,symbolname_pointer->name);
//	logwrite_s(Log);
	if(symbolname_pointer->dimfirst_pointer != NULL){
//		logwrite_s("symbolname_pointer->dimfirst_pointer\n");
//		printf("name:%s\n",symbolname_pointer->name);
//		printf("1:symbolname_pointer:%d\n",symbolname_pointer->stringdim_num);
		symboldim_free(symbolname_pointer->dimfirst_pointer);
//		printf("%d\n",symbolname_pointer->dimfirst_pointer);
		free(symbolname_pointer->dimfirst_pointer);
		symbolname_pointer->dimfirst_pointer = NULL;
	}

//	logwrite_s("name\n");
	if(symbolname_pointer->name != NULL){
//		logwrite_s("symbolname_pointer->name\n");
//		printf("%d\n",symbolname_pointer->name);
//		printf("2:stringname_pointert_name:%s\n",symbolname_pointer->name);
		free(symbolname_pointer->name);
		symbolname_pointer->name = NULL;
	}
//	logwrite_s("string\n");
	if(symbolname_pointer->string != NULL){
//		logwrite_s("symbolname_pointer->string\n");
		free(symbolname_pointer->string);
		symbolname_pointer->string = NULL;
	}
	
	return;
}

void symbol::symboldim_free(struct stringdim *stringdim_pointer)
{
	char log[1024];

//	logwrite_s("symbol::symboldim_free\n");
//	sprintf(log,"pointer:%d\n",stringdim_pointer->next_pointer);
//	logwrite_s(log);
	if(stringdim_pointer->next_pointer != NULL){
//		logwrite_s("stringdim_pointer->next_pointer\n");
//		printf("1:symboldim_free:%d:%s\n",stringdim_pointer->next_pointer,stringdim_pointer->string);
		symboldim_free(stringdim_pointer->next_pointer);
//		printf("%d\n",stringdim_pointer->next_pointer);
		free(stringdim_pointer->next_pointer);
		stringdim_pointer->next_pointer = NULL;
		
	}else{
//		logwrite_s("stringdim_pointer->next_pointer NULL\n");
//		printf("NULL\n");
//		printf("2:string:%d:%s\n",stringdim_pointer->next_pointer,stringdim_pointer->string);
	}
//	logwrite_s("string\n");
	if(stringdim_pointer->string != NULL){
//		logwrite_s("stringdim_pointer->string\n");
		free(stringdim_pointer->string);
		stringdim_pointer->string = NULL;
	}
//	logwrite_s("symbol::symboldim_free end\n");
	
	return;
}


//int symbol::init(int num)
int symbol::init()
{
	int ret;
	// R[hGÅm
	
	if( (symbolname_pointer = (symbolname*)malloc(sizeof(symbolname))) == NULL){
		// error
		printf("Symbol̗̈揉ł܂\n");
		script_logwrite("Symbol̗̈揉ł܂\n");
		ret = NG;
	}else{
		printf("Symbol̗̈揉ɐ܂B\n");
		script_logwrite("Symbol̗̈揉ɐ܂B\n");
		symbolname_pointer->name = NULL;
		symbolname_pointer->string = NULL;
		symbolname_pointer->value = 0;
		symbolname_pointer->next_pointer = NULL;
		ret = OK;
	}
	symbol_num = 0;
//	symbol_max = num;
	dummy_string = '\0';
	
	return(ret);
}

int symbol::clear(void)
{
//	logwrite_s("symbol::clear\n");
	if(symbolname_pointer != NULL){
		symbolname_free(symbolname_pointer);
//		logwrite_s("symbolname_free\n");
	}
	free(symbolname_pointer);
	symbolname_pointer = NULL;
//	logwrite_s("symbolname_pointer\n");
	
	return(0);
}


int symbol::read_num(void)
{
	return(symbol_num);
}

// ϐ̍쐬
// łɓ̕ϐ݂Ăꍇ͔ԍ݂̂Ԃ
int symbol::make_entory(char *symbol,int valtype)
{
	int count1;
	int num;
	int ret;
	symbolname *symbol_pointer;		//i[Xg̃|C^
	stringdim *dim_pointer;			// char^z擪|C^
	
//	if(symbol_num >= symbol_max){
//		// I[o[t[
//		printf("ϐ̈̃I[o[t[\n");
//		script_logwrite("ϐ̈̃I[o[t[\n");
//		num = 0;			//R[h
//	}else{
		num = serch(symbol,valtype);
		if(num == -1){		// ł

			// Xg̏I[T
			symbol_pointer = symbolname_pointer;
			while(symbol_pointer->next_pointer != NULL){
				symbol_pointer = symbol_pointer->next_pointer;
			}
			// String̗̈m
			if((symbol_pointer->name = (char*)malloc(strlen(symbol)+1)) == NULL){
				// error
				printf("̃GÅmۂł܂\n");
				script_logwrite("̃GÅmۂł܂\n");
			}else{
				sprintf(LogTmp,"make:%s\n",symbol);
				script_logwrite(LogTmp);
				
				strcpy(symbol_pointer->name,symbol);
				symbol_pointer->value = 0;							// 
				symbol_pointer->string = NULL;						// 
				symbol_pointer->dimfirst_pointer = NULL;
				symbol_pointer->stringdim_num = 0;					// z̑傫 0
				// z̗̈m
//				if(valtype == TYPE_CHARDIM){			// type͌ォw肳B
					if( (symbol_pointer->dimfirst_pointer = (stringdim*)malloc(sizeof(stringdim))) == NULL){
						// error
						printf("z̗̈mۂł܂\n");
						script_logwrite("z̗̈mۂł܂\n");
					}else{
						dim_pointer = symbol_pointer->dimfirst_pointer;
						printf("z̗̈mۂɐ܂B%s \n",symbol);
						dim_pointer->string = NULL;						// 
						dim_pointer->next_pointer = NULL;
					}
//				}
				
				symbol_pointer->type = valtype;						// type̐ݒ
				num = symbol_num + Reserve_Num;
				symbol_num++;
				
				// Xg̗̎̈m
				if( (symbol_pointer->next_pointer = (symbolname*)malloc(sizeof(symbolname))) == NULL){
					// error
					printf("String̗̈mۂł܂\n");
					script_logwrite("Symbol̗̈mۂł܂\n");
				}else{
					symbol_pointer = symbol_pointer->next_pointer;
					printf("Symbol̗̈mۂɐ܂B%s \n",symbol);
					symbol_pointer->name = NULL;
					symbol_pointer->string = NULL;						// 
					symbol_pointer->dimfirst_pointer = NULL;
					symbol_pointer->next_pointer = NULL;
				}
			}
			
		}
//	}

	return(num);
}

int symbol::make(char *symbol)
{
	int num;
	
	num = make_entory(symbol,TYPE_NOT);
	
	return(num);
}

char *symbol::get_symbol_name(int num)
{
	symbolname *symbol_pointer;		//i[Xg̃|C^
//	stringname *string_pointer;		//i[Xg̃|C^
	char *ret;
	int count;
	
	num = num - Reserve_Num;
	if(num < symbol_num){
		symbol_pointer = symbolname_pointer;
		for(count=0;count<=num;count++){
			ret = symbol_pointer->name;
			symbol_pointer = symbol_pointer->next_pointer;
		}
	}else{
		// ͈͊O
		printf("̃I[o[t[\n");
		script_logwrite("̃I[o[t[\n");
		ret = NULL;
	}
	
	return(ret);
}

int symbol::serch(char *word,int valtype)
{
	int count;
	int loop;
	char *wptr;
	int sym;
	int ret;
	
	ret = -1;

	loop = ON;
	count = 0;
	while((count<symbol_num) && (loop == ON)){
		wptr = get_symbol_name(count+Reserve_Num);
		sym = get_symbol_type(count+Reserve_Num);
//		printf("_serch_string:%s:%s:\n",word,wptr);
		if((strcmp(wptr,word) == 0) && ((sym == valtype) || (valtype == TYPE_NOT)) ){
//			printf("mach!\n");
			loop = OFF;
			ret = count + Reserve_Num;
		}else{
			count++;
		}
	}
//	if(loop == OFF){
//		ret = ret + Reserve_Num;
//	}
	
	return(ret);
}

// ̊i[
int symbol::push_string(char *word)
{
	int num;
	
	num = make_entory(word,TYPE_STR);
//	set_symbol_type(num,TYPE_STR);
	
	return(num);

}


// ̎肾
char *symbol::pop_string(int num)
{

	return get_symbol_name(num);

}

// ϐtype̎o int:char
int symbol::get_symbol_type(int num)
{
	int ret;
	int count;
	symbolname *symbol_pointer;		//i[Xg̃|C^

	num = num - Reserve_Num;
	if(num >= symbol_num){
		printf("get_symbol_type:ϐ݂Ȃ\n");
		script_logwrite("get_symbol_type:ϐ݂Ȃ\n");
		ret = TYPE_NOT;							// ͈͊O
	}else{
		symbol_pointer = symbolname_pointer;
		for(count=0;count<=num;count++){
			ret = symbol_pointer->type;
			symbol_pointer = symbol_pointer->next_pointer;
		}
	}
	
	return(ret);
}

// ϐtype̐ݒ int:char
int symbol::set_symbol_type(int num,int valtype)
{
	int ret;
	int count;
	symbolname *symbol_pointer;		//i[Xg̃|C^

	num = num - Reserve_Num;
	if(num >= symbol_num){
		printf("set_symbol_type:ϐ݂Ȃ\n");
		script_logwrite("set_symbol_type:ϐ݂Ȃ\n");
		ret = NG;							// ͈͊O
	}else{
		symbol_pointer = symbolname_pointer;
		for(count=0;count<num;count++){
			symbol_pointer = symbol_pointer->next_pointer;
		}
		symbol_pointer->type = valtype;
		ret = OK;
	}
	
	return(ret);
}

// ϐ̒l̎o
int symbol::get_symbol_val(int num)
{
	int ret;
	int count;
	symbolname *symbol_pointer;		//i[Xg̃|C^

	num = num - Reserve_Num;
	if(num >= symbol_num){
		printf("get_symbol_val:ϐ݂Ȃ\n");
		script_logwrite("get_symbol_val:ϐ݂Ȃ\n");
		ret = 0;							// ͈͊O
	}else{
		symbol_pointer = symbolname_pointer;
		for(count=0;count<=num;count++){
			ret = symbol_pointer->value;
			symbol_pointer = symbol_pointer->next_pointer;
		}
	}
	
	return(ret);
}

// ϐ̒l̊i[
int symbol::set_symbol_val(int num,int val)
{
	int ret;
	int count;
	symbolname *symbol_pointer;		//i[Xg̃|C^

	num = num - Reserve_Num;
	if(num >= symbol_num){
		printf("set_symbol_val:ϐ݂Ȃ\n");
		script_logwrite("set_symbol_val:ϐ݂Ȃ\n");
		ret = NG;							// ͈͊O
	}else{
		symbol_pointer = symbolname_pointer;
		for(count=0;count<num;count++){
			symbol_pointer = symbol_pointer->next_pointer;
		}
		symbol_pointer->value = val;
		ret = OK;
	}
	
	return(ret);
}

// ̊i[
int symbol::set_symbol_str(int num,char *word)
{
	int ret;
	int count;
	symbolname *symbol_pointer;		//i[Xg̃|C^
	
//	printf("%d:%d\n",num,symbol_num);
	num = num - Reserve_Num;
	if(num >= symbol_num){
		printf("set_symbol_str:ϐ݂Ȃ\n");
		script_logwrite("set_symbol_str:ϐ݂Ȃ\n");
		ret = NG;
	}else{
		symbol_pointer = symbolname_pointer;
		for(count=0;count<num;count++){
			symbol_pointer = symbol_pointer->next_pointer;
		}
		
		if(symbol_pointer->type != TYPE_CHAR){
			printf("ϐ %s ́Aϐł͂Ȃ\n",symbol_pointer->name);
			sprintf(LogTmp,"ϐ %s ́Aϐł͂Ȃ\n",symbol_pointer->name);
			script_logwrite(LogTmp);
			ret = NG;
		}else{
			free(symbol_pointer->string);
			if((symbol_pointer->string = (char*)malloc(strlen(word)+1))==NULL){
				printf("ϐ %s ̊i[̈mۂłȂ\n",symbol_pointer->name);
				sprintf(LogTmp,"ϐ %s ̊i[̈mۂłȂ\n",symbol_pointer->name);
				script_logwrite(LogTmp);
				ret = NG;
			}else{
				strcpy(symbol_pointer->string,word);
				ret = OK;
			}
		}
	}
	
	return(ret);
}

// ̎o
char *symbol::get_symbol_str(int num)
{
	char *ret;
	int count;
	symbolname *symbol_pointer;		//i[Xg̃|C^
	
	num = num - Reserve_Num;
	if(num >= symbol_num){
		printf("get_symbol_str:ϐ݂Ȃ\n");
		script_logwrite("get_symbol_str:ϐ݂Ȃ\n");
		ret = NULL;
	}else{
		symbol_pointer = symbolname_pointer;
		for(count=0;count<num;count++){
			symbol_pointer = symbol_pointer->next_pointer;
		}
		
		if(symbol_pointer->type == TYPE_CHARDIM){
			itoa(symbol_pointer->stringdim_num,return_string,10);
			ret = return_string;
		}else if(symbol_pointer->type != TYPE_CHAR){
			printf("ϐ %s ́Aϐł͂Ȃ\n",symbol_pointer->name);
			sprintf(LogTmp,"ϐ %s ́Aϐł͂Ȃ\n",symbol_pointer->name);
			script_logwrite(LogTmp);
			*ret = NULL;
		}else{
			ret = symbol_pointer->string;
			if(ret == NULL){		// string̒gƂ̓_~[̃f[^ԂB
				printf("ϐ %s ́AłB\n",symbol_pointer->name);
				sprintf(LogTmp,"ϐ %s ́AłB\n",symbol_pointer->name);
				script_logwrite(LogTmp);
				ret = &dummy_string;
			}
		}
	}
	
	return(ret);
}

// z̊i[
int symbol::set_symbol_strdim(int num,int dim,char *word)
{
	int ret;
	int count;
	symbolname *symbol_pointer;		//i[Xg̃|C^
	stringdim *dim_pointer;			// char^z擪|C^
	
	printf("set_symbol_strdim:%d:%d:%s\n",num,dim,word);
	num = num - Reserve_Num;
	if(num >= symbol_num){
		printf("set_symbol_str:ϐ݂Ȃ\n");
		script_logwrite("set_symbol_str:ϐ݂Ȃ\n");
		ret = NG;
	}else{
		symbol_pointer = symbolname_pointer;
		for(count=0;count<num;count++){						// ϐ
			symbol_pointer = symbol_pointer->next_pointer;
		}
		
		if(symbol_pointer->type != TYPE_CHARDIM){
			printf("ϐ %s ́Azϐł͂Ȃ\n",symbol_pointer->name);
			sprintf(LogTmp,"ϐ %s ́Azϐł͂Ȃ\n",symbol_pointer->name);
			script_logwrite(LogTmp);
			ret = NG;
		}else{
			if(dim != -1){
				dim_pointer = symbol_pointer->dimfirst_pointer;
				printf("z̑傫 : %d\n",symbol_pointer->stringdim_num);
				
				if(symbol_pointer->stringdim_num >= dim){
					for(count=0;count<dim;count++){	// zvf
						dim_pointer = dim_pointer->next_pointer;
					}
					free(dim_pointer->string);
					if((dim_pointer->string = (char*)malloc(strlen(word)+1))==NULL){
						printf("ϐ %s ̊i[̈mۂłȂ\n",symbol_pointer->name);
						sprintf(LogTmp,"ϐ %s ̊i[̈mۂłȂ\n",symbol_pointer->name);
						script_logwrite(LogTmp);
						ret = NG;
					}else{
						strcpy(dim_pointer->string,word);
						printf("z̓e :%s\n",dim_pointer->string);
						ret = OK;
					}
				}else{
					for(count=0;count<symbol_pointer->stringdim_num;count++){	// zvf
						dim_pointer = dim_pointer->next_pointer;
					}
					for(count=symbol_pointer->stringdim_num;count<dim;count++){	// zvf
						printf("zvf:%d\n",count);
						symbol_pointer->stringdim_num++;
						if( (dim_pointer->next_pointer = (stringdim*)malloc(sizeof(stringdim))) == NULL){
							// error
							printf("z̗̈mۂł܂\n");
							script_logwrite("z̗̈mۂł܂\n");
						}else{
							dim_pointer = dim_pointer->next_pointer;
							printf("z̗̈mۂɐ܂B%d \n",count+1);
							dim_pointer->string = NULL;						// 
							dim_pointer->next_pointer = NULL;
						}
					}
					
					free(dim_pointer->string);
					if((dim_pointer->string = (char*)malloc(strlen(word)+1))==NULL){
						printf("ϐ %s ̊i[̈mۂłȂ\n",symbol_pointer->name);
						sprintf(LogTmp,"ϐ %s ̊i[̈mۂłȂ\n",symbol_pointer->name);
						script_logwrite(LogTmp);
						ret = NG;
					}else{
						strcpy(dim_pointer->string,word);
						printf("z̓e %d :%s\n",count,dim_pointer->string);
						ret = OK;
					}
				
				}
			}else{
				printf("z̃|C^łB\n");
			}
		}
	}
	
	return(ret);
}

// ̔z̎o
char *symbol::get_symbol_strdim(int num,int dim)
{
	int count;
	char *ret;
	symbolname *symbol_pointer;		//i[Xg̃|C^
	stringdim *dim_pointer;			// char^z擪|C^

	ret = NULL;
	
	printf("get_symbol_strdim:%d:%d\n",num,dim);

	num = num - Reserve_Num;
	if(num >= symbol_num){
		printf("set_symbol_str:ϐ݂Ȃ\n");
		script_logwrite("set_symbol_str:ϐ݂Ȃ\n");
		ret = NG;
	}else{
		symbol_pointer = symbolname_pointer;
		for(count=0;count<num;count++){						// ϐ
			symbol_pointer = symbol_pointer->next_pointer;
		}
		
		if(symbol_pointer->type != TYPE_CHARDIM){
			printf("ϐ %s ́Azϐł͂Ȃ\n",symbol_pointer->name);
			sprintf(LogTmp,"ϐ %s ́Azϐł͂Ȃ\n",symbol_pointer->name);
			script_logwrite(LogTmp);
			ret = NG;
		}else{
			if(dim != -1){
				dim_pointer = symbol_pointer->dimfirst_pointer;
				printf("z̑傫 : %d\n",symbol_pointer->stringdim_num);
				
				if(symbol_pointer->stringdim_num >= dim){
					for(count=0;count<dim;count++){	// zvf
						dim_pointer = dim_pointer->next_pointer;
					}
					
					ret = dim_pointer->string;
				}else{
					printf("z̒g܂B\n");
				}
			}else{
				printf("z̃|C^łB\n");
			}
		}
	}
	
	if(ret == NULL){
		printf("ϐ̒g܂B\n");
		ret = &dummy_string;
	}

	return(ret);
}

//---------------------------------------------------------------------------
//	̗̈mۂA̋LE肾sB
//---------------------------------------------------------------------------

class stringobj{
	struct stringname{
		char *name;
		stringname *next_pointer;
	};
	stringname *stringname_pointer;	//i[Xg̐擪|C^
	
	int string_num;				// ̐
	void stringname_free(struct stringname *stringname_pointer);	// Xg̗̈
	int serch_string(char *word);	// i[Ă镶̌

public:
	int init(void);				// 
	int clear(void);				// ̈̊J
	int push_string(char *word);	// ̊i[
	char *pop_string(int num);		// ̎肾
	int read_num(void);				// ̐
};

int stringobj::serch_string(char *word)
{
	int count;
	int loop;
	char *wptr;

	loop = ON;
	count = 0;
	while((count<string_num) && (loop == ON)){
		wptr = pop_string(count+(Reserve_Num + Code_Num));
//		printf("_serch_string:%s:%s:\n",word,wptr);
		if(strcmp(wptr,word) == 0){
//			printf("mach!\n");
			loop = OFF;
		}else{
			count++;
		}
	}
	
	return(count);
}

void stringobj::stringname_free(struct stringname *stringname_pointer){

	if(stringname_pointer->next_pointer != NULL){
//		printf("1:stringname_pointer:%s\n",stringname_pointer->name);
		stringname_free(stringname_pointer->next_pointer);
//		printf("%d\n",stringname_pointer->next_pointer);
		free(stringname_pointer->next_pointer);
	}
	if(stringname_pointer->name != NULL){
//		printf("%d\n",stringname_pointer->name);
//		printf("2:stringname_pointert_name:%s\n",stringname_pointer->name);
		free(stringname_pointer->name);
	}
	
	return;
}

int stringobj::init(void)
{
	int ret;
	// R[hGÅm
	
	if( (stringname_pointer = (stringname*)malloc(sizeof(stringname))) == NULL){
		// error
		printf("String̗̈mۂł܂\n");
		script_logwrite("String̗̈mۂł܂\n");
		ret = NG;
	}else{
		printf("String̗̈mۂɐ܂B\n");
		stringname_pointer->name = NULL;
		stringname_pointer->next_pointer = NULL;
	
		ret = OK;
	}
	
	string_num = 0;
	
	return(ret);
}

int stringobj::clear(void)
{
	stringname_free(stringname_pointer);
	free(stringname_pointer);
	
	return(0);
}

int stringobj::push_string(char *word)
{
	int ret;
	stringname *string_pointer;		//i[Xg̃|C^
	
	ret = serch_string(word);		// 񂪂łɓo^ĂȂTB
//	printf("serch_string:%d:\n",ret);
	if(ret == string_num){			// 񔭌ł
		// Xg̏I[T
		string_pointer = stringname_pointer;
		while(string_pointer->next_pointer != NULL){
			string_pointer = string_pointer->next_pointer;
		}
		// String̗̈m
		if((string_pointer->name = (char*)malloc(strlen(word)+1)) == NULL){
			// error
			printf("̃GÅmۂł܂\n");
			script_logwrite("̃GÅmۂł܂\n");
		}else{
			strcpy(string_pointer->name,word);
			ret = string_num;
			string_num++;
			
			// Xg̗̎̈m
			if( (string_pointer->next_pointer = (stringname*)malloc(sizeof(stringname))) == NULL){
				// error
				printf("String̗̈mۂł܂\n");
				script_logwrite("String̗̈mۂł܂\n");
			}else{
				string_pointer = string_pointer->next_pointer;
				printf("String̗̈mۂɐ܂B\n");
				string_pointer->name = NULL;
				string_pointer->next_pointer = NULL;
			}
		}
	}
	
	return(ret + (Reserve_Num + Code_Num));
}

char *stringobj::pop_string(int num)
{
	stringname *string_pointer;		//i[Xg̃|C^
	char *ret;
	int count;
	
	num = num - (Reserve_Num + Code_Num);
	if(num < string_num){
		string_pointer = stringname_pointer;
		for(count=0;count<=num;count++){
			ret = string_pointer->name;
			string_pointer = string_pointer->next_pointer;
		}
	}else{
		// ͈͊O
		printf("̃I[o[t[\n");
		script_logwrite("̃I[o[t[\n");
		ret = NULL;
	}
	
	return(ret);
}

int stringobj::read_num(void)
{
	return(string_num);
}


//-----

class stringobj_old{
	char **string;				// i[|C^̔z
	int *string_length;			// ̒i[̔z
	int string_num;				// ̐
	int string_max;				// ̍ő吔

public:
	int init(int num);				// 
	int clear(void);				// ̈̊J
	int push_string(char *word);	// ̊i[
	char *pop_string(int num);		// ̎肾
	int read_num(void);				// ̐
};

int stringobj_old::clear(void)
{
	int count1;
	
	for(count1=0;count1<string_num;count1++){
		free(string[count1]);
	}
	free(string);
	free(string_length);
	
	return(0);
}

int stringobj_old::read_num(void)
{
	return(string_num);
}

char *stringobj_old::pop_string(int num)
{
	char *ret;
	
	num = num - (Reserve_Num + Code_Num);
	if(num < string_num){
		ret = string[num];
	}else{
		// ͈͊O
		printf("̃I[o[t[\n");
		script_logwrite("̃I[o[t[\n");
		ret = NULL;
	}
	
	return(ret);
}

int stringobj_old::push_string(char *word)
{
	int ret;
	
	if(string_num < string_max){
		if((string[string_num] = (char*)malloc(strlen(word)+1)) == NULL){
			// error
			printf("̃GÅmۂł܂\n");
		}else{
			strcpy(string[string_num],word);
			string_length[string_num] = strlen(word);
			ret = string_num;
			string_num++;
		}
	}else{
			printf("I[o[t[\n");
	}
	
	return(ret + (Reserve_Num + Code_Num));
}

int stringobj_old::init(int num)
{
	int ret;
	// R[hGÅm
	if( ((string = (char**)malloc(num)) == NULL) || ((string_length = (int*)malloc(num)) == NULL) ){
		// error
		printf("R[hGÅmۂł܂\n");
		ret = NG;
	}else{
		ret = OK;
	}
	
	string_num = 0;
	string_max = num;
	
	return(ret);
}

//---------------------------------------------------------------------------

class c22event{
	int event;
	int reference0;
	int reference1;
	int reference2;
	int reference3;
	int reference4;
	int reference5;
	int reference6;
	int reference7;
//	int type[9];

	char *event_str;
	char *reference_str[8];
public:
//	int init(struct s20data inputevant);
	int init();
	int clear(void);
	int set_event(struct s20_data *inputevent);
	int get_event(struct s20_data *inputevent);
	int get(int num);
	int put(int num,int value);
	int set_type(int num,int type);
	int get_type(int num);
	int set_str(int num,char *word);		// 
	char *get_str(int num);					// 
};

int c22event::set_event(struct s20_data *inputevent)
{
	int ret;

	set_str(S22EVENT_EVENT,inputevent->event);
	set_str(S22EVENT_REFERENCE0,inputevent->reference0);
	set_str(S22EVENT_REFERENCE1,inputevent->reference1);
	set_str(S22EVENT_REFERENCE2,inputevent->reference2);
	set_str(S22EVENT_REFERENCE3,inputevent->reference3);
	set_str(S22EVENT_REFERENCE4,inputevent->reference4);
	set_str(S22EVENT_REFERENCE5,inputevent->reference5);
	set_str(S22EVENT_REFERENCE6,inputevent->reference6);
	set_str(S22EVENT_REFERENCE7,inputevent->reference7);

	return(ret);
}

int c22event::get_event(struct s20_data *inputevent)
{
	char *str;
	int ret;

	str = get_str(S22EVENT_EVENT);
	if(str != NULL){
		strcpy(inputevent->event,str);
	}
	str = get_str(S22EVENT_REFERENCE0);
	if(str != NULL){
		strcpy(inputevent->reference0,str);
	}
	str = get_str(S22EVENT_REFERENCE1);
	if(str != NULL){
		strcpy(inputevent->reference1,str);
	}
	str = get_str(S22EVENT_REFERENCE2);
	if(str != NULL){
		strcpy(inputevent->reference2,str);
	}
	str = get_str(S22EVENT_REFERENCE3);
	if(str != NULL){
		strcpy(inputevent->reference3,str);
	}
	str = get_str(S22EVENT_REFERENCE4);
	if(str != NULL){
		strcpy(inputevent->reference4,str);
	}
	str = get_str(S22EVENT_REFERENCE5);
	if(str != NULL){
		strcpy(inputevent->reference5,str);
	}
	str = get_str(S22EVENT_REFERENCE6);
	if(str != NULL){
		strcpy(inputevent->reference6,str);
	}
	str = get_str(S22EVENT_REFERENCE7);
	if(str != NULL){
		strcpy(inputevent->reference7,str);
	}
	
	return(ret);
}

int c22event::set_str(int num,char *word)
{
	int ret;

	if(num == S22EVENT_EVENT){
		free(event_str);
		if((event_str = (char*)malloc(strlen(word)+1)) == NULL){
			printf("stringGÅmۂł܂\n");
			script_logwrite("stringGÅmۂł܂\n");
			ret = NG;
		}else{
			strcpy(event_str,word);
			sprintf(LogTmp,"c22event::set_str::event:%s\n",event_str);
			script_logwrite(LogTmp);
			ret = OK;
		}
	}else if(num <= S22EVENT_REFERENCE7){
		free(reference_str[num - S22EVENT_REFERENCE0]);
		if((reference_str[num - S22EVENT_REFERENCE0] = (char*)malloc(strlen(word)+1)) == NULL){
			printf("stringGÅmۂł܂\n");
			script_logwrite("stringGÅmۂł܂\n");
			ret = NG;
		}else{
			strcpy(reference_str[num - S22EVENT_REFERENCE0],word);
			sprintf(LogTmp,"c22event::set_str::reference%d:%s\n",num - S22EVENT_REFERENCE0,reference_str[num - S22EVENT_REFERENCE0]);
			script_logwrite(LogTmp);
			ret = OK;
		}
	}else{
		// 
		ret = NULL;
	}
	
	return(ret);
}

char *c22event::get_str(int num)
{
	char *ret;

	if(num == S22EVENT_EVENT){
		ret = event_str;
//		script_logwrite("sakura_event\n");
	}else if(num <= S22EVENT_REFERENCE7){
		ret = reference_str[num - S22EVENT_REFERENCE0];
//		script_logwrite("sakura_reference\n");
//						sprintf(LogTmp,"get_str:%s\n",ret);
//						script_logwrite(LogTmp);
	}else{
		// 
		ret = NULL;
		script_logwrite("sakura_overeria");
	}
	
	return(ret);
}

int c22event::init(void)
{
	int count1;

	event = 0;
	reference0 = 0;
	reference1 = 0;
	reference2 = 0;
	reference3 = 0;
	reference4 = 0;
	reference5 = 0;
	reference6 = 0;
	reference7 = 0;
	
	event_str = NULL;
	for(count1=0;count1<=REFERENCE_MAX;count1++){
//		type[count1] = TYPE_NOT;
		reference_str[count1] = NULL;
	}
	
	return(0);
}

int c22event::clear(void)
{
	int count1;

	free(event_str);
	for(count1=0;count1<=REFERENCE_MAX;count1++){
		free(reference_str[count1]);
	}

	return(0);
}

int c22event::get(int num)
{
	int value;
	
	switch(num){
		case S22EVENT_EVENT:
			value = event;
			break;
		case S22EVENT_REFERENCE0:
			value = reference0;
			break;
		case S22EVENT_REFERENCE1:
			value = reference1;
			break;
		case S22EVENT_REFERENCE2:
			value = reference2;
			break;
		case S22EVENT_REFERENCE3:
			value = reference3;
			break;
		case S22EVENT_REFERENCE4:
			value = reference4;
			break;
		case S22EVENT_REFERENCE5:
			value = reference5;
			break;
		case S22EVENT_REFERENCE6:
			value = reference6;
			break;
		case S22EVENT_REFERENCE7:
			value = reference7;
			break;
	}
	
	return(value);
}

int c22event::put(int num,int value)
{
	switch(num){
		case S22EVENT_EVENT:
			event = value;
			break;
		case S22EVENT_REFERENCE0:
			reference0 = value;
			break;
		case S22EVENT_REFERENCE1:
			reference1 = value;
			break;
		case S22EVENT_REFERENCE2:
			reference2 = value;
			break;
		case S22EVENT_REFERENCE3:
			reference3 = value;
			break;
		case S22EVENT_REFERENCE4:
			reference4 = value;
			break;
		case S22EVENT_REFERENCE5:
			reference5 = value;
			break;
		case S22EVENT_REFERENCE6:
			reference6 = value;
			break;
		case S22EVENT_REFERENCE7:
			reference7 = value;
			break;
	}
	
	return(0);
}

