%{
/*#include "script_n.h"*/
#undef YYLMAX
#define YYLMAX 1024

#include "nasino.h"
#include "nasino_script.h"
#include "nasino_script.tab.h"
#define YY_SKIP_YYWRAP
#define STRMAX	640
int yywrap() { return 1; }
extern void lexerror();
double answer = 0;
int parse_line = 1;
char infile[256];
int strcount = 0;
char string_tmp[STRMAX];
%}
%option yylineno
%start STR COMM COMM_CPP
%%
<INITIAL>[ \t]  ;
<INITIAL>"+"		return(ADDOP);
<INITIAL>"-"		return(SUBOP);
<INITIAL>"*"		return(MULOP);
<INITIAL>"/"		return(DIVOP);
<INITIAL>"="		return(ASGNOP);
<INITIAL>"=="		return(EQOP);
<INITIAL>">"		return(GTOP);
<INITIAL>">="		return(GEOP);
<INITIAL>"<"		return(LSOP);
<INITIAL>"<="		return(LEOP);
<INITIAL>"!="		return(NTOP);
<INITIAL>"&&"		return(ANDOP);
<INITIAL>"||"		return(OROP);
<INITIAL>"&"		return(ANDCOP);
<INITIAL>"|"		return(ORCOP);
<INITIAL>"["		return(LB);
<INITIAL>"]"		return(RB);
<INITIAL>"{"		return(LC);
<INITIAL>"}"		return(RC);
<INITIAL>"("		return(LP);
<INITIAL>")"		return(RP);
<INITIAL>";"		return(SM);
<INITIAL>","		return(CM);
<INITIAL>\"			{
						strcount = 0;
						BEGIN STR;
					}
<INITIAL>int		return(INT);
<INITIAL>char		return(CHAR);
<INITIAL>if			return(IF);
<INITIAL>else		return(ELSE);
<INITIAL>strcpy		return(STRCPYOP);
<INITIAL>strcmp		return(STRCMPOP);
<INITIAL>strcat		return(STRCATOP);
<INITIAL>sstpsend	return(SSTPSENDOP);
<INITIAL>get_initfiledata	return(GET_INITFILEDATAOP);
<INITIAL>save		return(SAVEOP);
<INITIAL>load		return(LOADOP);
<INITIAL>atoi		{
						return(ATOIOP);
					}
<INITIAL>itoa		{
						return(ITOAOP);
					}
<INITIAL>rand		return(RANDOP);
<INITIAL>date		return(DATEOP);
<INITIAL>saoricall	return(SAORICALLOP);
<INITIAL>event		{
						yylval.idno = SHIORI_EVENT;
						return(IDENT);
					};
<INITIAL>reference0		{
						yylval.idno = SHIORI_REFERENCE0;
						return(IDENT);
					};
<INITIAL>reference1		{
						yylval.idno = SHIORI_REFERENCE1;
						return(IDENT);
					};
<INITIAL>reference2		{
						yylval.idno = SHIORI_REFERENCE2;
						return(IDENT);
					};
<INITIAL>reference3		{
						yylval.idno = SHIORI_REFERENCE3;
						return(IDENT);
					};
<INITIAL>reference4		{
						yylval.idno = SHIORI_REFERENCE4;
						return(IDENT);
					};
<INITIAL>reference5		{
						yylval.idno = SHIORI_REFERENCE5;
						return(IDENT);
					};
<INITIAL>reference6		{
						yylval.idno = SHIORI_REFERENCE6;
						return(IDENT);
					};
<INITIAL>reference7		{
						yylval.idno = SHIORI_REFERENCE7;
						return(IDENT);
					};
<INITIAL>user_event		{
						yylval.idno = USER_EVENT;
						return(IDENT);
					};
<INITIAL>user_reference0		{
						yylval.idno = USER_REFERENCE0;
						return(IDENT);
					};
<INITIAL>user_reference1		{
						yylval.idno = USER_REFERENCE1;
						return(IDENT);
					};
<INITIAL>user_reference2		{
						yylval.idno = USER_REFERENCE2;
						return(IDENT);
					};
<INITIAL>user_reference3		{
						yylval.idno = USER_REFERENCE3;
						return(IDENT);
					};
<INITIAL>user_reference4		{
						yylval.idno = USER_REFERENCE4;
						return(IDENT);
					};
<INITIAL>user_reference5		{
						yylval.idno = USER_REFERENCE5;
						return(IDENT);
					};
<INITIAL>user_reference6		{
						yylval.idno = USER_REFERENCE6;
						return(IDENT);
					};
<INITIAL>user_reference7		{
						yylval.idno = USER_REFERENCE7;
						return(IDENT);
					};
<INITIAL>[A-Za-z][A-Za-z0-9_]* {		/* ̃V{ */
						int sp = symbol_look(yytext);
						yylval.idno = sp;
						if(nasino_script_getstringtype(sp) == TYPE_CHARDIM){
							return(DIMM);
						}else{
							return(IDENT);
						}
					};
<INITIAL>"/*"		BEGIN COMM;
<INITIAL>"//"		BEGIN COMM_CPP;

<INITIAL>[0-9]+		{ yylval.num = atoi(yytext); return NUMBER; }
<INITIAL>\n 		;
<STR>\"				{
						if(strcount >= STRMAX){
						}
						string_tmp[strcount] = '\0';
						yylval.pointer = string_pool(string_tmp);
						BEGIN INITIAL;
						return STRING;
					}
<STR>\\r			{
						if(strcount < STRMAX){
							string_tmp[strcount++] = '\r';
						}
					}
<STR>\\n			{
						if(strcount < STRMAX){
							string_tmp[strcount++] = '\n';
						}
					}
<STR>\\\"			{
						if(strcount < STRMAX){
							string_tmp[strcount++] = '"';
						}
					}
<STR>\\\\			{
						if(strcount < STRMAX){
							string_tmp[strcount++] = '\\';
						}
					}
<STR>\\				;
<STR>.				{
						printf("%c",yytext[0]);
						if(strcount < STRMAX){
							string_tmp[strcount++] = yytext[0];
						}
					}
<COMM>"*/"			BEGIN INITIAL;
<COMM>\n			;
<COMM>.				;

<COMM_CPP>\n		BEGIN INITIAL;
<COMM_CPP>.			;

. return yytext[0];
%%

void lexerror(char *s)
{
	extern int yynerrs,yylineno;
	
	++yynerrs;

}

