//---------------------------------------------------------------------------
//	Takahiro Hayashi 2002.02.04
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------
#include <windows.h>
//#include "nasino.h"

#define SAORI_DYNAMIC	0
#define SAORI_STATIC	1

typedef BOOL (*load)(HGLOBAL , long );
typedef BOOL (*unload)(void);
typedef HGLOBAL (*request)(HGLOBAL , long *);

class Saori{
	HINSTANCE hLib;
	load saori_load;			// load()
	unload saori_unload;		// unload()
	request saori_request;		// reauest()
	
	char *dllname;				// dll̖
	char *dllpath;				// dllpath
	unsigned int dllmode;		// dll̓샂[h/DYNAMIC/STATIC
	Saori* next_pointer;
	
	char LogTmp[AnswerLength];
public:
	Saori();
	int init(void);					// 
	int clear(void);
	int set_dllname(char *name);	// dll̖O̐ݒ
	char *get_dllname(void);		
	int set_dllpath(char *path);	// dll̖O̐ݒ
	char *get_dllpath(void);		
	int set_dllmode(unsigned int mode);		// dll̃[hݒ
	int get_dllmode(void);			// dll̃[h擾
	int set_nextpointer(void);
	Saori *get_nextpointer(void);
	int load_dll(char *path,char *base_path);		// dll̃AhXmۂload
	int unload_dll(void);		// dll̉
	
	int request_saori(char* buffer);
};

int Saori::set_dllmode(unsigned int mode)
{
	int ret;
	
	switch(mode){
		case SAORI_DYNAMIC:
		case SAORI_STATIC:
			dllmode = mode;
			ret = OK;
			break;
		default:
			ret = NG;
	}
	
	return(ret);
}


int Saori::get_dllmode(void)
{
	return(dllmode);
}


int Saori::request_saori(char* buffer)
{
	long len;
	HGLOBAL request_data;								// 
	HGLOBAL return_data;								// 

	len = strlen(buffer);
	request_data=GlobalAlloc(GMEM_FIXED,len);
	memcpy((char *)request_data,buffer,len );
//	printf("request send:%s:\n",buffer);

	return_data = saori_request(request_data,&len);
	
	free(buffer);
	if((buffer = (char*)malloc(len+1)) == NULL){
	
	}else{
//		memcpy( buffer, ((char *)GlobalLock(request_data)), len );
		memcpy( buffer, ((char *)GlobalLock(return_data)), len );
		buffer[len] = '\0';
//		buffer[len +1] = 0x00;
//		printf("request_saori return:%s:\n",buffer);
	}
	GlobalFree(return_data);

	return(OK);
}

Saori::Saori()
{
	hLib = NULL;
	saori_load = NULL;
	saori_unload = NULL;
	saori_request = NULL;

}

int Saori::load_dll(char *path,char *base_path)
{
	int ret;
	HGLOBAL request_data;								// 
	long len;
	unsigned int count;
	int pathlen;
	char *dllpath;

//	printf("load_dll:%s\n",path);
	
	if((hLib = LoadLibrary(path)) != NULL){
//		saori_load = (load)GetProcAddress(hLib, "load");
		saori_unload = (unload)GetProcAddress(hLib, "unload");
		saori_request = (request)GetProcAddress(hLib, "request");
		
		if((saori_load = (load)GetProcAddress(hLib, "load")) == NULL){
			printf("load is not export!\n");
		}else{
			printf("dll loading.\n");
			pathlen = strlen(path);
			if(base_path[strlen(base_path)-1] != '\\'){
				pathlen += strlen(base_path)+1;
			}else{
				pathlen += strlen(base_path);
			}
			if((dllpath = (char*)malloc(pathlen+1))==NULL){
				printf("DLL path malloc error!\n");
				ret = NG;
			}else{
				// dllɓnpath쐻
				strcpy(dllpath,base_path);
				if(base_path[strlen(dllpath)-1] != '\\'){
					strcat(dllpath,"\\");
				}
				strcat(dllpath,path);
				count = strlen(dllpath);
				while(dllpath[count] != '\\'){
					count--;
				}
				dllpath[count+1] = '\0';
				printf("path:%s\n",dllpath);

				len = strlen(dllpath);
				request_data=GlobalAlloc(GMEM_FIXED,len);
				memcpy((char *)request_data,dllpath,len );
				if(saori_load(request_data,len) == TRUE){
					ret = OK;
				}else{
					ret = NG;
				}
			}
		}
		free(dllpath);
		
	}else{
		printf("NG\n");
		ret = NG;
	}
	
	return(ret);
}

int Saori::unload_dll(void)
{
	int ret;

//	printf("unload_dll:%s:%s\n",path,dllname);
	if(get_dllmode() == SAORI_STATIC){
		saori_unload();
		
		if(FreeLibrary(hLib) != NULL){
			ret = OK;
		}else{
			ret = NG;
		}
	}else{
		ret = OK;
	}
	
	return(ret);
}

int Saori::init(void)
{
	hLib = NULL;
	saori_load = NULL;
	saori_unload = NULL;
	saori_request = NULL;

	next_pointer = NULL;
	dllname = NULL;
	dllpath = NULL;

	return(0);
}

int Saori::clear(void)
{
//	printf("clear:%d\n",next_pointer);
	if(next_pointer != NULL){
//		printf("nextfree:%d\n",next_pointer);
		next_pointer->clear();
//		printf("free:%d\n",next_pointer);
		unload_dll();					// dll̉
//		printf("dllname:%s\n",dllname);
		free(dllname);
		free(dllpath);
		free(next_pointer);
		dllname = NULL;
		dllpath = NULL;
		next_pointer = NULL;
	}else{
//		printf("return:%s:%s\n",dllname,dllpath);
	}

	return(OK);
}

int Saori::set_dllname(char *name)	// dll̖O̐ݒ
{
	int ret;

	if( (dllname = (char*)malloc(strlen(name)+1)) == NULL){
		ret = 0;
	}else{
		strcpy(dllname,name);
		ret = 1;
	}
	
	return(ret);
}

char *Saori::get_dllname(void)
{
//	printf("dllname:%s\n",dllname);
	return(dllname);
}


int Saori::set_dllpath(char *path)	// dllpath̐ݒ
{
	int ret;

	if( (dllpath = (char*)malloc(strlen(path)+1)) == NULL){
		ret = 0;
	}else{
		strcpy(dllpath,path);
		ret = 1;
	}
	
	return(ret);
}

char *Saori::get_dllpath(void)
{
	return(dllpath);
}

int Saori::set_nextpointer(void)
{
	int ret;
	
	if( (next_pointer = (Saori*)malloc(sizeof(Saori))) == NULL){
		printf("set_nextpointer NG\n");
		ret = NG;
	}else{
		next_pointer->init();
		ret = OK;
	}

	return(ret);
}

Saori *Saori::get_nextpointer(void)
{
//	printf("next_pointer:%d\n",next_pointer);
	return(next_pointer);
}


//---------------------------------------------------------------------------

class Saori_data{
	Saori *Saori_FirstPointer;			// dll̓o^NX̐擪|C^
	unsigned int Saori_DLLNum;			// dll̒ʂԍ
	char *BasePath;						// shiorîpath
	
	char LogTmp[AnswerLength];
public:
	Saori_data();
	int init(char* path);
	int clear(void);
	int dataset(char *data_buffer,Saori *inidata);		// dll̓o^
	int call_saori(char* name,char* buffer);			// dll Ăяo
	unsigned int get_saoridll_num(void);
	int test(void);
};

Saori_data::Saori_data()
{
	Saori_FirstPointer = NULL;
	Saori_DLLNum = 0;
}


int Saori_data::test(void)
{
	int ret;
	
	printf("Saori_FirstPointer:%d\n",Saori_FirstPointer);
	printf("test:%s\n\n",Saori_FirstPointer->get_dllname());
	
	return(ret);
}

//
// bufferrequest_saoriňUfeeêŁAmalloc|C^n
int Saori_data::call_saori(char* name,char* buffer)
{
	int loop;
	Saori *inidata;
	int ret;
	
//	printf("call_saori:%s\n",name);

	inidata = Saori_FirstPointer;
	do{
		if(inidata->get_nextpointer() != NULL){
			if(strcmp(name,inidata->get_dllname()) != 0){
				inidata = inidata->get_nextpointer();
				loop = 0;
			}else{
				loop = 1;
			}
		}else{
			loop = 2;
		}
	}while(loop == 0);
	
	if(loop == 1){
//		printf("call saori:%s\n",inidata->get_dllname());
		inidata->request_saori(buffer);
		ret = OK;
	}else{
		ret = NG;
	}
	
	return(ret);
}

//		SAORÏ̗
int Saori_data::clear(void)
{
	if( Saori_FirstPointer != NULL){
		Saori_FirstPointer->clear();
	}
	free(Saori_FirstPointer);
	Saori_FirstPointer = NULL;
	
	return(OK);
}

//		SAORȈ
int Saori_data::init(char* path)
{
	FILE *fp_ini;			/* saori.ini */
	char data_buffer[DicBufferLength];		/* ̓ǂݏodata */
	char ini_path[1024];
	int ret_data;
	Saori *inidata;
	
	strcpy(ini_path,path);
	strcat(ini_path,"saori.ini");
	
	script_logwrite("Saori_data::init\n");
//	if((fp_ini=fopen("saori.ini","rt"))==NULL){
	if((fp_ini=fopen(ini_path,"rt"))==NULL){
		/* saori.ini don't open!! */
		printf("saori.ini don't open!!\n");
		script_logwrite("saori.ini don't open!!\n");
		return(FALSE);
	}else{
		
		if( (BasePath = (char*)malloc(strlen(path)+1)) == NULL){
		
		}else{
			strcpy(BasePath,path);
			printf("BasePath:%s\n",BasePath);
			sprintf(LogTmp,"BasePath:%s\nini_path:%s\n",BasePath,ini_path);
			script_logwrite(LogTmp);
		}
		
		
		if( (Saori_FirstPointer = (Saori*)malloc(sizeof(Saori))) == NULL){
			printf("init malloc error!");
		}else{
			Saori_DLLNum = 0;
			inidata = Saori_FirstPointer;
			inidata->init();
			while( fgets(data_buffer,DicBufferLength,fp_ini) != NULL){
				ret_data = dataset(data_buffer,inidata);
				if(ret_data == OK){
					inidata = inidata->get_nextpointer();
				}else{
//					printf("data_set NG!\n");
				}
				
			}
		}
//		fclose(fp_ini);
	}
	
	return(OK);
}

//		SAORIdataݒ
int Saori_data::dataset(char *data_buffer,Saori *inidata)
{
	int ret;
	char word[DicBufferLength];				/* ؂odata */
	char path[DicBufferLength];				/* ؂odata */
	char temp[DicBufferLength];				/* ؂odata */
//	Saori *ini_pointer = NULL;
	
//	printf("Saori_data::dataset:%d\n",inidata);
	
	read_space(data_buffer);				// buffer擪 ' ' , '\t' , ',' B
	if( (data_buffer[0] != '#') && (data_buffer[0] != '\n') ){
	
		strcpy(path,BasePath);
		
		getkeyword_one(word,data_buffer);		// dll̖O؂o
		read_space(data_buffer);				// buffer擪 ' ' , '\t' , ',' B
		getsym(data_buffer);					// : ̂Ă
//		getbufword(path,data_buffer);			// path؂o
		getbufword(temp,data_buffer);			// path؂o
		strcat(path,temp);
		sprintf(LogTmp,"path:%s\n",path);
		script_logwrite(LogTmp);
		
		if((inidata->load_dll(path,BasePath)) == OK){	// dllload
//			if( (ini_pointer = (Saori*)malloc(sizeof(Saori))) == NULL){
//				printf("saori_dataset() malloc error!\n");
//				ret = NG;
//			}else{
//				printf("inidata:%d\n",inidata);
//				printf("ini_pointer:%d\n",ini_pointer);
//				Saori_DLLNum++;
			
//				inidata->set_dllname(word);				// dll̖̓o^
//				inidata->set_dllpath(path);				// dll̑patho^
//				inidata->set_nextpointer();
//				printf("name:%s\n",inidata->get_dllname());
//				sprintf(LogTmp,"name:%s\n",inidata->get_dllname());
//				script_logwrite(LogTmp);
//				printf("path:%s\n",inidata->get_dllpath());
//				sprintf(LogTmp,"path:%s\n",inidata->get_dllpath());
//				script_logwrite(LogTmp);
		
//				ret = OK;
//			}
			inidata->set_dllmode(SAORI_STATIC);		// ÓIĂяo
		}else{
			// dll loads
			inidata->set_dllmode(SAORI_DYNAMIC);	// IĂяo
			printf("%sloadł܂łB\n",path);
			sprintf(LogTmp,"%sloadł܂łB\n",path);
			script_logwrite(LogTmp);
//			ret = NG;
		}
		Saori_DLLNum++;
			
		inidata->set_dllname(word);				// dll̖̓o^
		inidata->set_dllpath(path);				// dll̑patho^
		inidata->set_nextpointer();
		printf("name:%s\n",inidata->get_dllname());
		sprintf(LogTmp,"name:%s\n",inidata->get_dllname());
		script_logwrite(LogTmp);
		printf("path:%s\n",inidata->get_dllpath());
		sprintf(LogTmp,"path:%s\n",inidata->get_dllpath());
		script_logwrite(LogTmp);
		
		ret = OK;
	}else{
		ret = NG;
	}
	
	return(ret);
}

unsigned int Saori_data::get_saoridll_num(void)
{
	return(Saori_DLLNum);
}




